org.hibernate.search.cfg.spi

## Interface DirectoryProviderService<D extends Directory>

- Type Parameters:
    `D` - a Lucene directory provider
  All Superinterfaces:
    Service
  All Known Implementing Classes:
    BaseDirectoryProviderService, DefaultDirectoryProviderService

      public interface DirectoryProviderService<D extends Directory>
      extends Service

  This Service allows to customize the creation of `DirectoryProvider` instances, potentially making use of shortcuts for the implementation names and altering default implementations.
  Author:
    gustavonalle

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `DirectoryProvider<D>` | `create(Properties indexProperties, String indexName, BuildContext context)` Creates a DirectoryProvider for an index based on the configuration
    `Class<? extends DirectoryProvider<D>>` | `getDefault()` Default `DirectoryProvider` to be used if none is configured by the user
    `String` | `toFullyQualifiedClassName(String shortcut)` Resolve short names into implementation names

- - ### Method Detail

    - #### create

          DirectoryProvider<D> create(Properties indexProperties,
                                      String indexName,
                                      BuildContext context)

      Creates a DirectoryProvider for an index based on the configuration
      Parameters:
        `indexProperties` - the configuration properties
        `indexName` - the name of the index (directory) to create
        `context` - provide access to some services at initialization
      Returns:
        a `DirectoryProvider`

    - #### getDefault

          Class<? extends DirectoryProvider<D>> getDefault()

      Default `DirectoryProvider` to be used if none is configured by the user
      Returns:
        the default `DirectoryProvider`

    - #### toFullyQualifiedClassName

          String toFullyQualifiedClassName(String shortcut)

      Resolve short names into implementation names
      Parameters:
        `shortcut` - the short name of the directory provider
      Returns:
        the fully qualified class name of the directory provider identified by the shortcut

Copyright © 2006-2017 Red Hat, Inc. All Rights Reserved